/*
cdsonic "Time Stones" powers
	by Lach
		edited by Whisper

No stealing pl0x. If you wanna use parts of this script, ask me first.
Honestly this script is disappointingly messy compared the lovely rework that is LUA_CDSC, but whatever; I'm done working on this fucking sprite rip.
*/

freeslot("SPR_CDTS", "S_CDPOWER1", "S_CDPOWER2", "MT_CDPOWER", "MT_TIMESTONE")
freeslot("S_PLAY_HOME1", "S_PLAY_HOME2", "SPR2_HOM1", "SPR2_HOM2", "S_PLAY_FANIMATION")

function A_FuseFade(mo)
	if not mo.fuse then mo.fuse = 8 end
	mo.frame = ($ & FF_FRAMEMASK) | ((9-mo.fuse) * TR_TRANS10) | FF_FULLBRIGHT
end

local function ridShieldPowers(mo)
	mo.cddrop = nil
	mo.cdfall = nil
	mo.cdbounce = nil
end

local function ringCost(player,n)
	player.health = $ - n
	player.mo.health = $ - n
end

states[S_CDPOWER1] = {
	sprite = SPR_CDTS,
	tics = 2,
	frame = FF_FULLBRIGHT,
	nextstate = S_CDPOWER2,
	action = A_FuseFade
}

states[S_CDPOWER2] = {
	sprite = SPR_CDTS,
	tics = 2,
	frame = B|FF_FULLBRIGHT,
	nextstate = S_CDPOWER1,
	action = A_FuseFade
}

states[S_PLAY_HOME1] = {
	sprite = SPR_PLAY,
	frame = SPR2_HOM1,
	tics = 18,
	nextstate = S_PLAY_FALL
}

states[S_PLAY_HOME2] = {
	sprite = SPR_PLAY,
	frame = SPR2_HOM2,
	tics = 18,
	nextstate = S_PLAY_FALL
}

states[S_PLAY_FANIMATION] = {
	sprite = SPR_SCFA,
	frame = FF_ANIMATE|A,
	tics = 18,
	var1 = 4,
	var2 = 3,
	nextstate = S_PLAY_FALL
}

mobjinfo[MT_CDPOWER] = {
	spawnstate = S_CDPOWER1,
	flags = MF_NOGRAVITY,
	height = 32*FRACUNIT,
	radius = 16*FRACUNIT
}

mobjinfo[MT_TIMESTONE] = {
	spawnstate = S_CEMG7,
	flags = MF_NOGRAVITY,
	height = 48*FRACUNIT,
	radius = 16*FRACUNIT,
	speed = 80*FRACUNIT
}

local colors = {SKINCOLOR_EMERALD, SKINCOLOR_MAGENTA, SKINCOLOR_BLUE, SKINCOLOR_CYAN, SKINCOLOR_GOLD, SKINCOLOR_RED, SKINCOLOR_SILVER}

local function CD_Homing(mobj, targ)
	local maxspd = 40
	if mobj.player and mobj.player.powers[pw_super] > 0 then
		maxspd = 65
	end
	targ = $ or mobj.target
	if targ then
		local mz = mobj.z+mobj.height/2
		local tz = targ.z+targ.height/2
		local tdist = P_AproxDistance(P_AproxDistance(mobj.x-targ.x,mobj.y-targ.y),mz-tz)
		local hangle = R_PointToAngle2(mobj.x,mobj.y,targ.x,targ.y)
		local vangle = R_PointToAngle2(0,0,P_AproxDistance(mobj.x-targ.x,mobj.y-targ.y),mz-tz)
		mobj.momx = $/8
		mobj.momy = $/8
		P_Thrust(mobj, hangle, FixedMul(min(tdist, maxspd*mobj.scale), cos(vangle)))
		mobj.momz = -FixedMul(min(tdist, maxspd*mobj.scale), sin(vangle)) + $/8
	end
end

local function P_LookForMoreEnemies(player)
	if P_LookForEnemies(player)
		return true
	end
	player.mo.eflags = not ($ & MFE_VERTICALFLIP) and ($ | MFE_VERTICALFLIP) or ($ & ~MFE_VERTICALFLIP)
	if P_LookForEnemies(player)
		player.mo.eflags = not ($ & MFE_VERTICALFLIP) and ($ | MFE_VERTICALFLIP) or ($ & ~MFE_VERTICALFLIP)
		return true
	end
	player.mo.eflags = not ($ & MFE_VERTICALFLIP) and ($ | MFE_VERTICALFLIP) or ($ & ~MFE_VERTICALFLIP)
	return false
end

local function P_LookForRing(mo)
	A_FindTarget(mo, MT_RING)
	while mo.target and mo.target.valid and not mo.target.health and mo.target.type ~= MT_SPARK
		mo.target.type = MT_SPARK
		A_FindTarget(mo, MT_RING)
	end
	if mo.target and mo.target.valid and P_AproxDistance(P_AproxDistance(mo.x-mo.target.x,mo.y-mo.target.y),mo.z-mo.target.z) <= 256*mo.scale
		return true
	end
	return false
end

local homingpose = {
	S_PLAY_HOME1,
	S_PLAY_HOME2,
	S_PLAY_FANIMATION
}

addHook("ThinkFrame", do
	for player in players.iterate
			-- make sure ring consume cooldown exists
			if player.consumecooldown == nil
				player.consumecooldown = 0
			-- there is no ring consumption while super
			elseif player.powers[pw_super]
				player.consumecooldown = 1
			-- deplete timer
			elseif player.consumecooldown > 0
				player.consumecooldown = $-1
			end
		if not player.mo
		or player.mo.skin ~= "cdsonic"
		or player.exiting
		or player.powers[pw_carry] == CR_NIGHTSMODE
			continue
		end
		
		local mo = player.mo
		
		mo.altfuturestone = $ or 0
		
		//Tells the game when cdsonic presses, but not holds, next weapon
	
		if mo.cdnext ~= nil and player.cmd.buttons & BT_WEAPONNEXT
			mo.cdnext = $ + 1
		else mo.cdnext = 0
		end
		
		//Tells the game when cdsonic presses, but not holds, previous weapon
	
		if mo.cdprev ~= nil and player.cmd.buttons & BT_WEAPONPREV
			mo.cdprev = $ + 1
		else mo.cdprev = 0
		end
		
		//Tells the game when cdsonic presses, but not holds, fire
	
		if mo.cdfire ~= nil and player.cmd.buttons & BT_ATTACK
			mo.cdfire = $ + 1
		else mo.cdfire = 0
		end
		
		//Tells the game when cdsonic presses, but not holds, fire normal
	
		if mo.cdfire2 ~= nil and player.cmd.buttons & BT_FIRENORMAL
			mo.cdfire2 = $ + 1
		else mo.cdfire2 = 0
		end
		
		//Tells the game when cdsonic presses, but not holds, custom 1
	
		if mo.cdc1 ~= nil and player.cmd.buttons & BT_CUSTOM1
			mo.cdc1 = $ + 1
		else mo.cdc1 = 0
		end
		
		//handles weapon selection
		
		local button = player.cmd.buttons & BT_WEAPONMASK
		if button and button ~= mo.currentstone and mo.altfuturestone <= 0
			mo.currentstone = button
			S_StartSound(nil,sfx_wepchg,player)
		end
		
		local fire = mo.cdfire == 1 or mo.cdfire2 == 1 or mo.cdc1 == 1
		local charge = mo.cdfire or mo.cdfire2 or mo.cdc1
		
		if mo.currentstone == nil then mo.currentstone = 0 end
		
		if mo.cdnext == 1 and mo.altfuturestone <= 0
			mo.currentstone = $ + 1
			S_StartSound(nil,sfx_wepchg,player)
			if mo.currentstone > 7
				mo.currentstone = 0
			end
		end
		
		if mo.cdprev == 1 and mo.altfuturestone <= 0
			mo.currentstone = $ - 1
			S_StartSound(nil,sfx_wepchg,player)
			if mo.currentstone < 0
				mo.currentstone = 7
			end
		end
		
		//Super shtuff. Disabled for 2.2
	
/*		if player.powers[pw_super]
			if mo.state == S_PLAY_SUPERWALK1
				mo.state = S_PLAY_SUPERWALK2
			end
			if mo.state == S_PLAY_CARRY
				mo.state = S_PLAY_CLIMB4
			end
		end */
		
		//oh snap emerdood powahs??!??!
		
		local stone
		if mo.currentstone
			stone = 1
			for n = 1,(player.mo.currentstone)-1
				stone = 2*$
			end
			stone = player.powers[pw_emeralds] & $ or emeralds & $
		end
		
		if not mo.cdtics and (mo.emeraldpower == 6 and mo.currentstone ~=6 or mo.emeraldpower ~=6) and P_IsObjectOnGround(mo)
			mo.emeraldpower = nil
		end
		if G_RingSlingerGametype()
			mo.currentstone = 0
		elseif mo.health and stone and not mo.cdtics and (mo.emeraldpower == 6 or not P_PlayerInPain(player))
		and not player.powers[pw_carry]
		and not player.powers[pw_nocontrol]
			if stone == 1 //Slow Fall
				if player.rings == 0 
					end
				if fire and not P_IsObjectOnGround(mo) and player.rings > 0
					mo.emeraldpower = mo.currentstone
					mo.cdtics = 1
					player.pflags = $ & ~PF_JUMPED & ~PF_SPINNING
					S_StartSound(mo,sfx_cdfm23)
					ridShieldPowers(mo)
				end
			elseif stone == 2 //Low Gravity
				if player.rings == 0
					end
				if fire and player.rings > 0
					mo.emeraldpower = mo.currentstone
					mo.cdtics = 1
					S_StartSound(mo,sfx_cdfm23)
				end
			elseif stone == 4 //Homing Attack
				local tracr = P_LookForEnemies(player)
				if tracr then
					P_SpawnLockOn(mo.player, tracr, S_LOCKON3)	
				end
				if fire and tracr
					mo.emeraldpower = mo.currentstone
					mo.cdtics = 1
					S_StartSound(mo,sfx_cdfm23)
					player.pflags = $|PF_JUMPED|PF_THOKKED & ~PF_SPINNING
					mo.cdhoming = 20
					mo.state = S_PLAY_ROLL
					ridShieldPowers(mo)
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
				end
			elseif stone == 8 //Light Speed dash
				local tracr = P_LookForRing(mo)
				if tracr then
					P_SpawnLockOn(mo.player, mo.target, S_LOCKON3)	
				end
				if fire and tracr
					mo.emeraldpower = mo.currentstone
					mo.cdtics = 1
					S_StartSound(mo,sfx_cdfm23)
					player.pflags = $|PF_JUMPED|PF_THOKKED & ~PF_SPINNING
					mo.state = S_PLAY_ROLL
					mo.cdhoming = 20
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
					ridShieldPowers(mo)
				end
			elseif stone == 16 //Blitz
				if player.rings == 0
					end
				if mo.state == S_PLAY_RUN and player.rings > 0
					if player.consumecooldown == 0
						player.rings = $-1
						player.consumecooldown = 70
						if player.powers[pw_super]
							player.consumecooldown = 1
						end
					end
					mo.cdtics = 1
					S_StartSound(mo,sfx_cdfm23)
					mo.emeraldpower = mo.currentstone
				end
			elseif stone == 32 //PAST
				if player.rings == 0 or 1
					end
				local no = player.powers[pw_flashing] or mo.tracer and mo.tracer.type == MT_TUBEWAYPOINT
				if mo.emeraldpower ~= 6 or no
					mo.cdpast = {}
				end
				mo.emeraldpower = 6
				if not no
					if charge and player.rings > 1
						local n = mo.cdpast[#mo.cdpast]
						if n
							ridShieldPowers(mo)
							local z = mo.z
							local flags = player.pflags
							player.pflags = n[7] | PF_FULLSTASIS
							local z = mo.z
							mo.z = n[3]
							if P_TryMove(mo,n[1], n[2], true)
								mo.momx = n[4]
								mo.momy = n[5]
								mo.momz = n[6]
								mo.state = n[8]
								mo.frame = n[9]
								
								local shit = P_SpawnMobj(mo.x + cos(n[10]), mo.y + sin(n[10]), mo.z, MT_THOK)
								mo.prevtarget = mo.target
								mo.target = shit
								A_FaceTarget(mo)
								P_RemoveMobj(shit)
								mo.target = mo.prevtarget
								mo.cdtics = 1
								
								if fire
									S_StartSound(mo,sfx_cdfm23)
									S_StartSound(nil,sfx_cdpcm1,player)
									if not player.powers[pw_super] then
										player.rings = $-2
									end
								end
								table.remove(mo.cdpast)
							else
								mo.z = z
								player.pflags = flags
								mo.cdpast = {}
							end
						end
					else
						local spark = P_SpawnMobj(mo.x + P_RandomRange(-12,12)*mo.scale, mo.y + P_RandomRange(-12,12)*mo.scale, mo.z + P_RandomKey(42)*mo.scale, MT_CDPOWER)
						spark.color = SKINCOLOR_RED
						spark.scale = mo.scale/4
						table.insert(mo.cdpast, {
							mo.x,
							mo.y,
							mo.z,
							mo.momx,
							mo.momy,
							mo.momz,
							player.pflags,
							mo.state,
							mo.frame,
							mo.angle
						})
						if #mo.cdpast == 1
							S_StartSound(mo,sfx_cdfm23)
						end
					end
				end
			elseif stone == 64 //FUTURE
				if player.rings <= 9
					end
				mo.emeraldpower = 7
				/*if fire and not mo.futurestone and player.rings >=10
					mo.futurestone = P_SpawnPlayerMissile(mo, MT_TIMESTONE)
					if mo.futurestone
						mo.futurestone.eflags = mo.eflags
						mo.futurestone.target = mo
						player.rings = $-10
						if player.powers[pw_super]
						player.rings = $ + 10
						end
					end
					S_StartSound(mo,sfx_cdfm23)
				end*/
				if fire and mo.altfuturestone == 0 and player.rings >=10
					mo.altfuturestone = min(10 + FixedInt(FixedDiv(FixedHypot(FixedHypot(mo.momx,mo.momy), mo.momz),mo.scale)/3), 30)
					if not player.powers[pw_super]
						player.rings = max($ - 10, 0)
					end
					S_StartSound(mo,sfx_cdfm23)
					S_StartSound(nil,sfx_cdpcm0,mo.player)
					mo.futuremom = {mo.momx, mo.momy, mo.momz, mo.angle, max(FixedHypot(FixedHypot(mo.momx,mo.momy), 3*mo.momz/2),mo.scale*36), player.aiming}
				elseif mo.altfuturestone == 0 and player.rings >=10 then
					local spark = P_SpawnMobj(mo.x + P_RandomRange(-12,12)*mo.scale, mo.y + P_RandomRange(-12,12)*mo.scale, mo.z + P_RandomKey(42)*mo.scale, MT_CDPOWER)
					spark.color = SKINCOLOR_SILVER
					spark.scale = mo.scale/4
				end
				if mo.altfuturestone > 0 then
					mo.cdtics = 1
					mo.altfuturestone = $ - 1
					P_SpawnGhostMobj(player.mo).tics = 2
					player.pflags = ($|PF_FULLSTASIS) & ~PF_JUMPED & ~PF_SPINNING
					player.powers[pw_strong] = STR_GUARD
					player.mo.state = S_PLAY_ROLL
					P_InstaThrust(mo, mo.angle, FixedMul((20 + min(mo.altfuturestone, 20))*mo.futuremom[5]/20, cos(player.aiming)))
					mo.momz = FixedMul((16 + mo.altfuturestone)*mo.futuremom[5]/16, sin(player.aiming))
					player.drawangle = mo.angle
					mo.flags2 = $|MF2_DONTDRAW
					if mo.altfuturestone == 0 then
						mo.altfuturestone = -1
						player.powers[pw_strong] = STR_NONE
						player.mo.state = S_PLAY_SPRING
						mo.momz = $/2
						P_FlashPal(player, 1, 3)
						S_StartSound(mo,sfx_cdfm31)
						mo.flags2 = $&~ MF2_DONTDRAW
					end
				elseif mo.altfuturestone < 0
					if P_IsObjectOnGround(mo)
						mo.altfuturestone = 0
						S_StartSound(mo,sfx_cdfm23)
					end
				end
			end
		else
			if player.mo.currentstone ~= 8 and mo.altfuturestone and mo.altfuturestone > 0 then
				mo.futuremom = nil
				player.powers[pw_strong] = STR_NONE
				player.mo.state = S_PLAY_FALL
				mo.altfuturestone = 0
				mo.flags2 = $&~ MF2_DONTDRAW
			end
			mo.cdpast = {}
		end
		
		if mo.cdtics
			if P_PlayerInPain(player) or not mo.health or player.powers[pw_carry] == CR_ZOOMTUBE
				mo.cdtics = 0
			else
				local spark = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.eflags & MFE_VERTICALFLIP and mo.height - 32*mo.scale), MT_CDPOWER)
				spark.state = $ + (leveltime/2)%2
				spark.eflags = mo.eflags
				if not mo.emeraldpower or not colors[mo.emeraldpower]
					spark.color = SKINCOLOR_EMERALD
				else
					spark.color = colors[mo.emeraldpower]
				end
				spark.scale = mo.scale
				mo.cdtics = $ - 1
				if mo.currentstone == 1 and mo.emeraldpower == 1 //Slow Fall 
					if player.rings == 0
					end
					if charge and not P_IsObjectOnGround(mo) and not player.powers[pw_carry] and player.rings > 0
						mo.cdtics = $ + 1
						mo.momz = P_MobjFlip(mo)*max(P_MobjFlip(mo)*$, -2*mo.scale)
						if mo.state < S_CDFALL1 or mo.state > S_CDFALL5
							mo.state = S_CDFALL1
						end
						if player.consumecooldown == 0
							player.rings = $-1
							player.consumecooldown = 35
							if player.powers[pw_super]
								player.consumecooldown = 1
							end
						end						
					end
				elseif mo.currentstone == 2 and mo.emeraldpower == 2 //Low Gravity
					if player.rings == 0
					end
					if charge and player.rings > 0
						mo.cdtics = $ + 1
						if not P_IsObjectOnGround(mo)
							mo.momz = $ - P_GetMobjGravity(mo)/2
						end
						if player.consumecooldown == 0
							player.rings = $-1
							player.consumecooldown = 35
							if player.powers[pw_super]
								player.consumecooldown = 1
							end
						end						
					end
				elseif mo.emeraldpower == 3 //Homing Attack
					if not mo.tracer //Rather than bother actually fixing the script, I'll just do an extra LookforEnemies check.
					mo.tracer = P_LookForEnemies(player)
					end
					if not (mo.eflags & MFE_SPRUNG) and mo.tracer and mo.tracer.valid and mo.tracer.health and not (mo.tracer.flags2 & MF2_FRET) and mo.cdhoming
						mo.state = S_PLAY_ROLL
						CD_Homing(mo,mo.tracer)
						mo.cdtics = $+1
						mo.cdhoming = $-1
						mo.player.powers[pw_strong] = STR_ATTACK
					else
						mo.player.powers[pw_strong] = 0
						mo.cdhoming = nil
						mo.tracer = nil
						player.pflags = $ & ~(PF_SPINNING|PF_JUMPED|PF_STARTJUMP)
						if not (mo.eflags & MFE_SPRUNG) then
							P_InstaThrust(mo,R_PointToAngle2(0,0,mo.momx,mo.momy),min(player.speed,15*mo.scale))
							mo.momz = P_MobjFlip(mo)*8*mo.scale
						end
						mo.state = homingpose[P_RandomRange(1,3)]
					end
				elseif mo.emeraldpower == 4 //Light Speed dash
					if true then
						if mo.target and mo.target.valid and mo.target.health and mo.cdhoming
							mo.state = S_PLAY_ROLL
							CD_Homing(mo)
							player.pflags = $|PF_THOKKED
							local a = R_PointToAngle2(mo.x,mo.y,mo.target.x,mo.target.y)
							if abs(a - mo.angle) <= ANGLE_45 then
								mo.angle = mo.angle + (a - mo.angle)/8
							else
								mo.angle = mo.angle + (a - mo.angle)/4
							end
							mo.player.drawangle = a
							mo.cdtics = $ + 1
							mo.cdhoming = $ - 1
						elseif mo.cdhoming and P_LookForRing(mo)
							mo.cdhoming = 20
							mo.state = S_PLAY_ROLL
							player.pflags = $|PF_THOKKED
							CD_Homing(mo)
							local a = R_PointToAngle2(mo.x,mo.y,mo.target.x,mo.target.y)
							if abs(a - mo.angle) > ANG60 then
								mo.angle = mo.angle + (a - mo.angle)/10
							else
								mo.angle = mo.angle + (a - mo.angle)/5
							end
							mo.player.drawangle = a
							mo.cdtics = $ +1
							mo.cdhoming = $ -1
						else
							mo.angle = R_PointToAngle2(0,0,mo.momx,mo.momy)
							mo.cdhoming = nil
							player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
							if not charge then
								P_InstaThrust(mo,mo.angle,min(player.speed,8*mo.scale))
							end
							mo.momz = $/2
						end
					end
				elseif mo.currentstone == 5 and mo.emeraldpower == 5 //Blitz
					if player.rings == 0
						end
					if mo.state == S_PLAY_RUN or player.speed > FixedMul(mo.scale, player.runspeed) and player.rings > 0
						mo.cdtics = $ + 1
						mo.blitz = true
						player.powers[pw_strong] = $|STR_SPIKE|STR_WALL|STR_PUNCH|STR_STOMP
						if player.consumecooldown == 0
							player.rings = $-1
							player.consumecooldown = 35
							if player.powers[pw_super]
								player.consumecooldown = 1
							end
						end	
					elseif mo.blitz then
						player.powers[pw_strong] = $&~ (STR_SPIKE|STR_WALL|STR_PUNCH|STR_STOMP)
						mo.blitz = nil
					end
				end
			end
		end
		
		//ground animations fix
		
		if (mo.state >= S_CDRISE1 and mo.state <= S_CDLEAP2)
		and P_IsObjectOnGround(mo)
		and P_MobjFlip(mo)*mo.momz <= 0
		and not mo.emeraldpower
			mo.state = S_PLAY_WALK
		end
		
		if player.speed > 52*mo.scale and not (player.powers[pw_super] or player.powers[pw_sneakers]) and mo.altfuturestone <= 0
			P_SpawnGhostMobj(player.mo).tics = 2
		end
		if mo.emeraldpower ~= 5 and mo.blitz then
			player.powers[pw_strong] = $&~ (STR_SPIKE|STR_WALL|STR_PUNCH|STR_STOMP)
			mo.blitz = nil
		end
	end
end)

/*addHook("MobjMoveCollide", function(mo,item)
	if mo and mo.skin == "cdsonic" and mo.emeraldpower == 5 and mo.cdtics and mo.player
	and item and item.flags & MF_SHOOTABLE and not item.player
	and not (mo.player.ctfteam == 1 and item.type == MT_BLUERINGBOX or mo.player.ctfteam == 2 and item.type == MT_REDRINGBOX)
	and mo.z <= item.z + item.height and item.z <= mo.z + mo.height
		P_DamageMobj(item, mo,mo)
	end
end, MT_PLAYER)*/

addHook("MobjThinker", function(mo)
	if P_AproxDistance(P_AproxDistance(mo.momx, mo.momy), mo.momz) < 80*mo.scale
		if mo.target.valid and mo.target.currentstone == 7 and (emeralds & 64 or mo.target.player.powers[pw_emeralds] & 64) and mo.target.health and P_CheckPosition(mo.target, mo.x, mo.y, mo.z)
			mo.target.momx = 0
			mo.target.momy = 0
			mo.target.momz = 0
			P_TeleportMove(mo.target, mo.x, mo.y, mo.z)
			mo.target.player.pflags = $ & ~PF_JUMPED & ~PF_SPINNING
			mo.target.state = S_PLAY_FALL
			P_FlashPal(mo.target.player, 1, 3)
			S_StartSound(mo.target,sfx_cdfm23)
			S_StartSound(nil,sfx_cdpcm0,mo.target.player)
		end
		mo.target.futurestone = nil
		P_RemoveMobj(mo)
	else
		local spark = P_SpawnMobj(mo.x + P_RandomRange(-4,4)*mo.scale, mo.y + P_RandomRange(-4,4)*mo.scale, mo.z + P_RandomKey(4)*mo.scale, MT_CDPOWER)
		spark.color = SKINCOLOR_SILVER
		spark.scale = mo.scale/4
	end
end, MT_TIMESTONE)

hud.add(function(v,player)
	if G_RingSlingerGametype()
	or not player.mo
	or player.mo.skin ~= "cdsonic"
	or player.mo.currentstone == nil
	or (player.powers[pw_carry] == CR_NIGHTSMODE)
		return
	end
	
	local mo = player.mo
	
	for i = 0,6
		local stone = 1
		if (player.mo.currentstone + 5 + i)%8 == 0
		stone = "NOMOVE"
		else
			for n = 1,(player.mo.currentstone + 4 + i)%8
				stone = 2*$
			end
			stone = player.powers[pw_emeralds] & $ or emeralds & $
			if stone
				stone = "CHAOS" + ((player.mo.currentstone + 5 + i)%8)
			else
				stone = "CHAOSN"
			end
		end
		v.drawScaled((218 + i*10)*FRACUNIT,180*FRACUNIT,FRACUNIT/2,v.cachePatch(stone), V_SNAPTORIGHT|V_SNAPTOTOP|(V_20TRANS * abs(3-i)))
	end
	v.drawScaled(247*FRACUNIT,179*FRACUNIT,FRACUNIT/2,v.cachePatch("CURWEAP"), V_SNAPTORIGHT|V_SNAPTOTOP)
end,"game")